{############################################################################
#                                                                           #
#  SLX Cube V3 :: 3D Cube Screen Saver                                      #
#  Copyright (C) 2000-2005  N.G van der Westhuizen                          #
#                                                                           #
#    This program is free software; you can redistribute it and/or modify   #
#    it under the terms of the GNU General Public License as published by   #
#    the Free Software Foundation; either version 2 of the License, or      #
#    (at your option) any later version.                                    #
#                                                                           #
#    This program is distributed in the hope that it will be useful,        #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of         #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
#    GNU General Public License for more details.                           #
#                                                                           #
#    You should have received a copy of the GNU General Public License      #
#    along with this program; if not, write to the Free Software            #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston,                  #
#    MA  02111-1307  USA                                                    #
#    http://www.fsf.org                                                     #
#                                                                           #
#                                                                           #
#  N.G van der Westhuizen                                                   #
#  P.O Box 563, Rosettenville, JHB, 2130, South-Africa                      #
#  http://www.slx.za.net                                                    #
#  info@slx.za.net                                                          #
#                                                                           #
############################################################################}

{############################################################################
#                                                                           #
#  The 3D Rendering is made possible using the following code:              #
#  http://www.programmersheaven.com/search/download.asp?FileID=500          #
#                                                                           #
############################################################################}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ClipBrd, Registry, INIFiles, JPEG;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    Image10: TImage;
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
   procedure WMHotKey(var Msg: TWMHotKey); message WM_HOTKEY;
  public
    { Public declarations }
   Procedure Preview_Screen;
   Procedure Configuration_Screen;
   Procedure Full_Screen;

   Procedure Preview_Screen_Setup;

   Procedure Exit_Sub_Scr(var Msg: TMsg; var Handled: Boolean);
   Procedure Close_Saver;

   Procedure Set_Password;
   Procedure Get_Password;

   Procedure Read_INI_File;
   Procedure Assign_Default_Image(Image: Integer);

   Procedure Start_The_3D_Cube_Stuff;

   procedure Calculate;
   procedure Direction;
  end;

CONST
 id_SnapShot = 101; //Used for the "PrintScreen" Key
 INI_FILE_NAME = 'slx_cube.ini';

Const
 Cube: Array[0..23] of Integer = (40, 40, 40,
                                 -40, 40, 40,
                                 -40,-40, 40,
                                  40,-40, 40,
                                  40, 40,-40,
                                 -40, 40,-40,
                                 -40,-40,-40,
                                  40,-40,-40);
CONST
 MaxPixelCount = 32768;

Const
  TEX_X = 127; //Texture mask (width of texture bitmap - 1)
  TEX_Y = 127; //Texture mask (height of texture bitmap - 1)

type
  ScanPoints = (NoPoints, OnePoint, TwoPoints); //Note: Convex polygons only!

  ScanType = record     //One of these for each Y coord on screen
    points: ScanPoints; //Either none, one, or two points
    x1, x2: Integer;    //X coord of two points max (Y coord is from position in array)
    u1, v1, z1: Single; //Texture coordinates
    u2, v2, z2: Single; //Texture coordinates
  end;

  VertType = record
    x, y, z: Integer; //Coordinates of vertex in worldspace
    sx, sy: Integer;  //Screen coordinate after projection
    u, v: Single;     //Coordinate of texture at this vertex
  end;

TYPE
 pRGBArray  =  ^TRGBArray;    // Use SysUtils.pByteArray for 8-bit color
 TRGBArray  =  ARRAY[0..MaxPixelCount-1] OF TRGBTriple;

var
 Form1: TForm1;

//This is to set the cube size...
 HSCALE, VSCALE: ShortInt;

//Just to Remember in what mode we are in.
 Mode: String;

//This is to get the Current Windows Version.
 Version: DWORD;
 MajorVersion, MinorVersion: BYTE;
 Windows_Version: String;

//This is to save the contents of the Windows clipboard.
 Buffer_Text: String;
 Buffer_Bitmap: TBitmap;
 Used_Buffer: String;

//Used to Hide the Windows Taskbar.
 hTaskBar: THandle;

//This is to see if the mouse have been moved.
 Mouse_Events: Integer;

 INI_File: TiniFile;
 INI_FileName: String;
 Image_List: Array[1..6] of String;
 Time_Delay: Integer;

////////////

  Bitmap: TBitmap; //We will draw onto this then blit to the screen.

  SCREEN_X, SCREEN_Y, MID_X, MID_Y: Integer; //Screen info
  tex1: array[0..TEX_X, 0..TEX_Y] of TColor; //Holds the texture pixels
  tex2: array[0..TEX_X, 0..TEX_Y] of TColor; //Holds the texture pixels
  tex3: array[0..TEX_X, 0..TEX_Y] of TColor; //Holds the texture pixels
  tex4: array[0..TEX_X, 0..TEX_Y] of TColor; //Holds the texture pixels
  tex5: array[0..TEX_X, 0..TEX_Y] of TColor; //Holds the texture pixels
  tex6: array[0..TEX_X, 0..TEX_Y] of TColor; //Holds the texture pixels
  scan: array[0..1023] of ScanType; //One for each potential screen Y coord
  v: array[0..3] of VertType; //Hold the vertices

  P1_X, P1_Y, P1_Z: Integer;
  P2_X, P2_Y, P2_Z: Integer;
  P3_X, P3_Y, P3_Z: Integer;
  P4_X, P4_Y, P4_Z: Integer;

  Zan, Yan, Xan: Real;
  Xt, Yt, Zt: Integer;
  X, Y, Z: Integer;

  Cube_Line_Points: Array of Integer;

  Select_Image: Integer;
  
/////////////

  Direction_1: Integer; //Left or Right Movement
  Direction_2: Integer; //Up_Left, Up_Right, Down_Left, Down_Right
  Speed: Integer;
  Max_Limit_X: Integer;
  Max_Limit_Y: Integer;

  X_Loop, Y_Loop: Integer;

implementation

{$R *.DFM}

//***************************************************************
//This Code sets the mode of views, and calls the relavant procedures
//***************************************************************

Procedure TForm1.Preview_Screen;
Begin
 Mode := 'Preview';
 Preview_Screen_Setup;
end;

Procedure TForm1.Configuration_Screen;
Begin
 Mode := 'Configuration';
end;

Procedure TForm1.Full_Screen;
Begin
 Mode := 'Full_Screen';
end;

//***************************************************************
//This will setup the little preview screen
//***************************************************************

Procedure TForm1.Preview_Screen_Setup;
Var
 DemoWnd: HWnd;
 MyRect: TRect;
 MyCanvas: TCanvas;
 ScrWidth, ScrHeight: Integer;
 Back_Bitmap: TBitmap;
Begin
 DemoWnd := StrToInt(ParamStr(2));

 Try
  While not IsWindowVisible(DemoWnd) do
   Application.ProcessMessages;

  GetWindowRect(DemoWnd,MyRect);
  ScrWidth := MyRect.Right-MyRect.Left + 1;
  ScrHeight := MyRect.Bottom-MyRect.Top + 1;

  MyRect := Rect(0, 0, ScrWidth - 1, ScrHeight - 1);
  MyCanvas := TCanvas.Create;
  MyCanvas.Handle := GetDC(DemoWnd);
  MyCanvas.Pen.Color := clWhite;

  Back_Bitmap := TBitmap.Create;
  Back_Bitmap.Handle := GetDC(DemoWnd);
  Back_Bitmap.Assign (Image1.Picture);

  while IsWindowVisible(DemoWnd) do
   Begin
    MyCanvas.Draw(0, 0, Back_Bitmap);
   end;

  Back_Bitmap.Free;
  MyCanvas.Free;
 Except
  Halt(0);
 end;
end;

//***************************************************************
// This code is for when the Screen saver Starts and Closes.
//***************************************************************

procedure TForm1.FormShow(Sender: TObject);
begin
 Try
  Windows_Version := 'Unknown';
  Version := GetVersion();
  MajorVersion := LOBYTE(LOWORD(Version));    //Get major and minor version numbers of Windows
  MinorVersion := HIBYTE(LOWORD(Version));    //Get build numbers for Windows NT or Win32s

  if (Version and $80000000) = 0 then
   Windows_Version := 'Windows NT'
  else
   if (MajorVersion < 4) then
    Windows_Version := 'Win32s'
   else
    Windows_Version := 'Windows 95/98'; //Windows 95/98 -- No build numbers provided

  RegisterHotKey(Form1.Handle, id_SnapShot, 0, VK_SNAPSHOT);

  if Clipboard.HasFormat(CF_TEXT) then
   Begin
    Buffer_Text := ClipBoard.AsText;
    Used_Buffer := 'Text';
   end;

  if Clipboard.HasFormat(CF_Bitmap) then
   Begin
    Buffer_Bitmap := TBitmap.Create;
    Buffer_Bitmap.Handle := Form1.Handle;
    Buffer_Bitmap.Assign (ClipBoard);
    Used_Buffer := 'Bitmap';
   end;

  Read_INI_File;
  Start_The_3D_Cube_Stuff;
  Timer1.Enabled := True;
 Except
  Halt(0);
 end;
end;

Procedure TForm1.Start_The_3D_Cube_Stuff;
var
 i, j: Integer;
Begin
  SCREEN_X := Image2.Width; //The bitmap is made to fit its container
  SCREEN_Y := Image2.Height;
  MID_X := SCREEN_X div 2;
  MID_Y := SCREEN_Y div 2;

  //Make our drawing surface - CreateDIBSection would be preferable...
  Bitmap := TBitmap.Create;
  Bitmap.Width := SCREEN_X;
  Bitmap.Height := SCREEN_Y;

  for i:=0 to TEX_X do
   for j:= 0 to TEX_Y do
    tex1[i,j] := Image3.Canvas.Pixels[i,j];

  for i:=0 to TEX_X do
   for j:= 0 to TEX_Y do
    tex2[i,j] := Image4.Canvas.Pixels[i,j];

  for i:=0 to TEX_X do
   for j:= 0 to TEX_Y do
    tex3[i,j] := Image5.Canvas.Pixels[i,j];

  for i:=0 to TEX_X do
   for j:=0 to TEX_Y do
    tex4[i,j] := Image6.Canvas.Pixels[TEX_X-i,j];

  for i:=0 to TEX_X do
   for j:= 0 to TEX_Y do
    tex5[i,j] := Image7.Canvas.Pixels[TEX_X-i,j];

  for i:=0 to TEX_X do
   for j:= 0 to TEX_Y do
    tex6[i,j] := Image8.Canvas.Pixels[TEX_X-i,j];

//>>>>>>>>>>>>>>>>>>>>

 P1_X := -80;
 P1_Y := 80;
 P1_Z := 5;

 P2_X := 80;
 P2_Y := 80;
 P2_Z := 20;

 P3_X := 80;
 P3_Y := -80;
 P3_Z := 20;

 P4_X := -80;
 P4_Y := -80;
 P4_Z := 5;

 Randomize;

 Zan :=  0.6;
 Xan :=  0.6;
 Yan :=  Xan;

 SetLength (Cube_Line_Points, 25);

 Select_Image := 1;

 X_Loop := Random(Screen.Width - Bitmap.Width);
 Y_Loop := Random(Screen.Height - Bitmap.Height);

 Direction_1 := 2; //Left or Right Movement
 Direction_2 := 2; //Up_Left, Up_Right, Down_Left, Down_Right

 Max_Limit_X := Bitmap.Width;
 Max_Limit_Y := Bitmap.Height;
 Speed := 4;
end;

Procedure TForm1.FormActivate(Sender: TObject);
begin
 Try
  ShowWindow(Application.Handle, SW_HIDE);     //This Should Hides it from the Task Bar.

  hTaskbar := FindWindow('Shell_TrayWnd', Nil); //This should hide the Windows Taskbar.
  ShowWindow(hTaskBar, SW_HIDE);

  Mouse_Events := 0;
  Application.OnMessage := Exit_Sub_Scr;

  Form1.Left := 0;
  Form1.Top := 0;

  ShowCursor (False);
 Except
  Halt(0);
 end;
end;

Procedure TForm1.Read_INI_File;
Var
 Loop: Integer;
 BlockRect1, BlockRect2: TRect;
 Temp_Bmp: TBitmap;
Begin
 BlockRect1 := Rect(0, 0, TEX_X+1, TEX_Y+1);

 INI_FileName := ExtractFileDir(Paramstr(0)) + '\' + INI_FILE_NAME;
 INI_File := TiniFile.Create (INI_FileName);

 Time_Delay := INI_File.ReadInteger('Time', 'Delay', 1);
 Timer1.Interval := Time_Delay;

 HSCALE := INI_File.ReadInteger('Scale', 'Scale', 5);
 HSCALE := HSCALE + 5;
 if (HSCALE > 20) then
  HSCALE := 20;
 VSCALE := HSCALE;

 if (HSCALE > 10) then
  Begin
   Image2.Width :=  Image2.Width + (HSCALE * (HSCALE - 10));
   Image2.Height := Image2.Width;
  end
 else
  Begin
   Image2.Width :=  Image2.Width - (HSCALE * (10 - HSCALE));
   Image2.Height := Image2.Width;
  end;

 For Loop := 1 to 6 do
  Begin
   Image_List[Loop] := INI_File.ReadString('Images', IntToStr(Loop), '');

   Try
    if FileExists(Image_List[Loop]) then
     Begin
      Image10.Picture.LoadFromFile (Image_List[Loop]);
      BlockRect2 := Rect(0, 0, Image10.Width, Image10.Height);

      Temp_Bmp := TBitmap.Create;
      Temp_Bmp.Assign (Image10.Picture.Graphic);

      Case Loop of
       1: Image3.Canvas.CopyRect(BlockRect1, Temp_Bmp.Canvas, BlockRect2);
       2: Image4.Canvas.CopyRect(BlockRect1, Temp_Bmp.Canvas, BlockRect2);
       3: Image5.Canvas.CopyRect(BlockRect1, Temp_Bmp.Canvas, BlockRect2);
       4: Image6.Canvas.CopyRect(BlockRect1, Temp_Bmp.Canvas, BlockRect2);
       5: Image7.Canvas.CopyRect(BlockRect1, Temp_Bmp.Canvas, BlockRect2);
       6: Image8.Canvas.CopyRect(BlockRect1, Temp_Bmp.Canvas, BlockRect2);
      end;

      Temp_Bmp.Free;
     end
    else
     Assign_Default_Image(Loop);
   Except
    Assign_Default_Image(Loop);
   end;
  end;

 INI_File.Free;
end;

Procedure TForm1.Assign_Default_Image(Image: Integer);
Begin
 Case Image of
  1: Image3.Picture.Assign (Image9.Picture);
  2: Image4.Picture.Assign (Image9.Picture);
  3: Image5.Picture.Assign (Image9.Picture);
  4: Image6.Picture.Assign (Image9.Picture);
  5: Image7.Picture.Assign (Image9.Picture);
  6: Image8.Picture.Assign (Image9.Picture);
 end;
end;

Procedure TForm1.FormDestroy(Sender: TObject);
begin
 Try
  Bitmap.Free;

  hTaskbar := FindWindow('Shell_TrayWnd', Nil);
  ShowWindow(hTaskBar, SW_SHOWNORMAL);

  UnRegisterHotKey (Form1.Handle, id_SnapShot);

 //Clear the Clipboard
  ClipBoard.Clear;

  if (Used_Buffer = 'Text') then
   ClipBoard.AsText := Buffer_Text;

  if (Used_Buffer = 'Bitmap') then
   ClipBoard.Assign (Buffer_Bitmap);

  Buffer_Bitmap.Free;
 Except
  Halt(0);
 end;
end;

//***************************************************************
//This receives the "on message" events sent to it
//***************************************************************

Procedure TForm1.Exit_Sub_Scr(var Msg: TMsg; var Handled: Boolean);
Begin
 if (MSG.Message = WM_KEYDOWN) then
  Begin
   ShowCursor (True);
   Close_Saver;
  end;

 if Msg.Message = WM_SYSCOMMAND then
  if (Msg.wParam = SC_SCREENSAVE) or (Msg.wParam = SC_MONITORPOWER) then
   Handled := True; // This should prevent a screensaver and PowerMonitor from Starting
end;

Procedure TForm1.WMHotKey (var Msg: TWMHotKey);  //This stops anything from being copied to the clipboard
begin
 Try
  if Msg.HotKey = id_SnapShot then
   Begin
    ClipBoard.Clear;

    if (Used_Buffer = 'Text') then
     ClipBoard.AsText := Buffer_Text;

    if (Used_Buffer = 'Bitmap') then
     ClipBoard.Assign (Buffer_Bitmap);

    ShowCursor (True);
    Close_Saver;
   end;
 Except
  Halt(0);
 end;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if (Mouse_Events > 2) then    //Ignore Mouse Move 3 Times
  Begin
   ShowCursor (True);
   Close_Saver;
  end
 else
  Mouse_Events := Mouse_Events + 1;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 ShowCursor (True);
 Close_Saver;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 ShowCursor (True);
 Close_Saver;
end;

procedure TForm1.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
 ShowCursor (True);
 Close_Saver;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
 ShowCursor (True);
 Close_Saver;
end;

//***************************************************************
//This will check whether to close in Windows 95,98 or NT (Security Checks)
//***************************************************************

Procedure TForm1.Close_Saver;
Begin
//This code will decide whether to run security checks
//Windows NT does the security itself, thus it should not run in the saver

 if (Windows_Version = 'Windows NT') or (Windows_Version = 'Unknown') then
  Close
 else
  Get_Password;
end;

//***************************************************************
//This handles the Password Screen
//***************************************************************

Procedure TForm1.Set_Password;
var
 hLib: THandle;
 P: function (a: PChar; ParentHandle: THandle; b, c: Integer): Integer; stdcall;
 SysDir: String;
 NewLength: Integer;
 ParamHandle: THandle;
begin
 SetLength (SysDir, MAX_PATH);
 NewLength := GetSystemDirectory (PChar (SysDir), MAX_PATH);
 SetLength (SysDir, NewLength);

 if (length (SysDir) > 0) and (SysDir [length (SysDir)] <> '\') then
  SysDir := SysDir + '\';

 hLib := LoadLibrary (PChar (SysDir + 'MPR.DLL'));

 if hLib <> 0 then
  Begin
   P := GetProcAddress (hLib, 'PwdChangePasswordA');

   Try
    ParamHandle := StrToInt (ParamStr (2));
   Except
    ParamHandle := 0;
   end;

   if assigned (P) then
    P ('SCRSAVE', ParamHandle, 0, 0);

   FreeLibrary (hLib);
  end;
end;

Procedure TForm1.Get_Password;
var
 hLib: THandle;
 P: function (Parent: THandle): Boolean; stdcall;
 SysDir: String;
 NewLength: Integer;
 Registry: TRegistry;
 OldValue: LongBool;
begin
 //Turns the "CTRL + ALT + Del" trap on
 SystemParametersInfo(97, Word(True), @OldValue, 0);

 if ((Mode = 'Configuration') or (Mode = 'Preview')) then
  Close
 else
  Begin
   //See if password must be checked
   Registry := TRegistry.Create;
   Registry.RootKey := HKEY_CURRENT_USER;

   if (Registry.OpenKey ('Control Panel\desktop', false)) then
    begin
     if (Registry.ReadInteger ('ScreenSaveUsePassword') <> 0) then
      begin
       ShowCursor (True);
       SetLength (SysDir, MAX_PATH);       //Load library PASSWORD.CPL from system-directory
       NewLength := GetSystemDirectory (PChar (SysDir), MAX_PATH);
       SetLength (SysDir, NewLength);

       if (length (SysDir) > 0) and (SysDir [length (SysDir)] <> '\') then
        SysDir := SysDir + '\';

       hLib := LoadLibrary (PChar (SysDir + 'PASSWORD.CPL'));

       if hLib = 0 then
         Close    //Close Saver if dll not found, simply close the saver
       else
        begin
         P := GetProcAddress (hLib, 'VerifyScreenSavePwd');  //show the password verification dialog

         if P (Handle) then
          Begin
           FreeLibrary (hLib); //unload PASSWORD.CPL
           ShowCursor (False);
           Close;
          end;

        end;
       ShowCursor (False);
      end
     else
      close;
    end;
  end;

 ShowCursor (False);
 Mouse_Events := 0;

 //Turns the "CTRL + ALT + Del" trap off
 SystemParametersInfo(97, Word(False), @OldValue, 0);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
Begin
 Try
  Zan := Zan + 0.01;
  Xan := Xan + 0.03;
  Yan := Yan + 0.06;

  if (Xan > 19.42) then //Reset the count so that the number does not grow to big
   Begin                //At 18 : the sequence starts all over again
    Zan :=  0.6;
    Xan :=  0.6;
    Yan :=  Xan;
   end;

  Calculate;
  Direction;
 Except
  Halt(0);
 end;
end;

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

procedure InitScans;
var
  i: Integer;
begin
  for i:=0 To SCREEN_Y do
    scan[i].points := NoPoints; //Empty all scanlines in the edge list
end;

procedure AddEdge(p1, p2: Integer);
var
  temp, i, v1, v2: Integer;
  dy: Single;
  xp, zp, up, vp: Single;     //Prime vars
  dxp, dzp, dup, dvp: Single; // Delta-Prime vars
  zp1, up1, vp1: Single;      //Primes of 1st point
  zp2, up2, vp2: Single;      //Primes of 2nd point
begin
  v1 := p1; //These are pointers - could be altered to Vertex pointers
  v2 := p2; //""

  //Horizontal lines are ignored
  if v[v1].sy = v[v2].sy then exit;

  if v[v2].sy < v[v1].sy then begin
    //Swap pointers
    temp := v1;
    v1 := v2;
    v2 := temp;
  end;

  zp1 := 1.0 / v[v1].z;
  up1 := v[v1].u * zp1;
  vp1 := v[v1].v * zp1;

  zp2 := 1.0 / v[v2].z;
  up2 := v[v2].u * zp2;
  vp2 := v[v2].v * zp2;

  xp := v[v1].sx;
  up := up1;
  vp := vp1;
  zp := zp1;

  dy := 1.0 / (v[v2].sy - v[v1].sy);
  dxp := (v[v2].sx - v[v1].sx) * dy;
  dup := (up2 - up1) * dy;
  dvp := (vp2 - vp1) * dy;
  dzp := (zp2 - zp1) * dy;

  for i:= v[v1].sy to v[v2].sy - 1 do begin
    if (i >= 0) and (i < SCREEN_Y) then
      case scan[i].points of
      NoPoints: begin
        scan[i].points := OnePoint;
        scan[i].x1 := Trunc(xp);
        scan[i].u1 := up;
        scan[i].v1 := vp;
        scan[i].z1 := zp;
        scan[i].x2 := Trunc(xp); //Copying to both points eliminates the
        scan[i].u2 := up;        //need to swap at case:OnePoints
        scan[i].v2 := vp;
        scan[i].z2 := zp;
      end;
      OnePoint: begin
        scan[i].points := TwoPoints;
        if scan[i].x1 > xp then begin
          scan[i].x1 := Trunc(xp);
          scan[i].u1 := up;
          scan[i].v1 := vp;
          scan[i].z1 := zp;
        end
        Else begin
          scan[i].x2 := Trunc(xp);
          scan[i].u2 := up;
          scan[i].v2 := vp;
          scan[i].z2 := zp;
        end;
      end;
    end;
    xp := xp + dxp;
    up := up + dup;
    vp := vp + dvp;
    zp := zp + dzp;
  end;
end;

procedure RenderScansPerspective;
var
  i, j: Integer;
  x1, x2, tx, ty: Integer;
  tu, tv, tz: Single;
  dtu, dtv, dtz: Single;
  Row: pRGBArray;
begin
  {
   Note that this procedure gives perfect results with no distortion.
   'Quake' uses sub-division for extra speed (sampling U and V at
   intervals of 16 bits and linearly interpolating). The distortion is
   hardly noticable.
  }

  Bitmap.PixelFormat := pf24bit;

  for i:= 0 To Bitmap.Height - 1 do
    if ((scan[i].points = TwoPoints) and (scan[i].x1 <> scan[i].x2)) then begin
      x1 := scan[i].x1;
      x2 := scan[i].x2;
      tu := scan[i].u1;
      tv := scan[i].v1;
      tz := scan[i].z1;
      dtu := (scan[i].u2 - tu) / (x2 - x1);
      dtv := (scan[i].v2 - tv) / (x2 - x1);
      dtz := (scan[i].z2 - tz) / (x2 - x1);
      Row := Bitmap.Scanline[i];

      for j:= x1 To x2 do begin
       tx := Trunc(tu / tz * TEX_X) and TEX_X;
       ty := Trunc(tv / tz * TEX_Y) and TEX_Y;

      Case Select_Image of
       1: Begin
           Row[j].rgbtRed := GetRvalue (Tex1[tx,ty]);
           Row[j].rgbtGreen := GetGvalue (Tex1[tx,ty]);
           Row[j].rgbtBlue := GetBvalue (Tex1[tx,ty]);
          end;
       2: Begin
           Row[j].rgbtRed := GetRvalue (Tex2[tx,ty]);
           Row[j].rgbtGreen := GetGvalue (Tex2[tx,ty]);
           Row[j].rgbtBlue := GetBvalue (Tex2[tx,ty]);
          end;
       3: Begin
           Row[j].rgbtRed := GetRvalue (Tex3[tx,ty]);
           Row[j].rgbtGreen := GetGvalue (Tex3[tx,ty]);
           Row[j].rgbtBlue := GetBvalue (Tex3[tx,ty]);
          end;
       4: Begin
           Row[j].rgbtRed := GetRvalue (Tex4[tx,ty]);
           Row[j].rgbtGreen := GetGvalue (Tex4[tx,ty]);
           Row[j].rgbtBlue := GetBvalue (Tex4[tx,ty]);
          end;
       5: Begin
           Row[j].rgbtRed := GetRvalue (Tex5[tx,ty]);
           Row[j].rgbtGreen := GetGvalue (Tex5[tx,ty]);
           Row[j].rgbtBlue := GetBvalue (Tex5[tx,ty]);
          end;
       6: Begin
           Row[j].rgbtRed := GetRvalue (Tex6[tx,ty]);
           Row[j].rgbtGreen := GetGvalue (Tex6[tx,ty]);
           Row[j].rgbtBlue := GetBvalue (Tex6[tx,ty]);
          end;
        End;

       tu := tu + dtu;
       tv := tv + dtv;
       tz := tz + dtz;
      end;
    end;
end;

procedure RenderScans;
begin
 RenderScansPerspective;
end;

procedure DrawTexturedPolygon;
var
  i, z: Integer;
  uv: Single;
begin

  try
  begin
    //Read vertex coords
    with Form1 do begin
      v[0].x := P1_X;  //point 1 : X
      v[0].y := P1_Y;  //point 1 : Y
      v[0].z := P1_Z;  //point 1 : Z

      v[1].x := P2_X;  //point 2 : Z
      v[1].y := P2_Y;  //point 2 : Y
      v[1].z := P2_Z;  //point 2 : Z

      v[2].x := P3_X;  //point 3 : X
      v[2].y := P3_Y;  //point 3 : Y
      v[2].z := P3_Z;  //point 3 : Z

      v[3].x := P4_X;  //point 4 : X
      v[3].y := P4_Y;  //point 4 : Y
      v[3].z := P4_Z;  //point 4 : Z
    end;

    //Texture coord's (floats)
    uv := 1; //uv will repeat the image
    v[0].u := 0.0;
    v[0].v := 0.0;
    v[1].u := uv;
    v[1].v := 0.0;
    v[2].u := uv;
    v[2].v := uv;
    v[3].u := 0.0;
    v[3].v := uv;

    //Perspective projection
    for i := 0 To 3 do begin
      z := v[i].z;
      if z = 0 Then z := 1; // Catch divide by zero.
      v[i].sx := (v[i].x * HSCALE div z) + MID_X;
      v[i].sy := (-v[i].y * VSCALE div z) + MID_Y;
    end;

    InitScans; //Set up the scanline edge list

    AddEdge(0,1); //Add an edge to the edge list
    AddEdge(1,2);
    AddEdge(2,3);
    AddEdge(3,0);

    RenderScans; //Draw any spans in the edge list

    Form1.Image2.Canvas.Draw(0, 0, Bitmap); //Blit to screen
  end;
  finally
  end;
end;

procedure TForm1.Calculate();
Var
 Loop: Integer;
 ZDistance: Integer;
 Z0, Z1, Z2, Z3: Integer;
begin
 Loop := 0;

 While (Loop < Length (Cube)) do
  Begin
   X := Cube [Loop];
    Loop := Loop + 1;
   Y := Cube [Loop];
    Loop := Loop + 1;
   Z := Cube [Loop];
    Loop := Loop + 1;

   Yt := Round(Y * COS(Xan) - Z * SIN(Xan));
   Zt := Round(Y * SIN(Xan) + Z * COS(Xan));
   Y := Yt;
   Z := Zt;
   Xt := Round(X * COS(Yan) - Z * SIN(Yan));
   Zt := Round(X * SIN(Yan) + Z * COS(Yan));
   X := Xt;
   Z := Zt;
   Cube_Line_Points[Loop - 1] := Z;

   Xt := Round(X * COS(Zan) - Y * SIN(Zan));
   Yt := Round(X * SIN(Zan) + Y * COS(Zan));
   X := Xt;       //<--we plot these!
   Y := Yt;       //<--we plot these!

   Cube_Line_Points[Loop - 3] := X;
   Cube_Line_Points[Loop - 2] := Y;
  end;

//>>>>>>>>>>>>>>>>>>>>>>>>>>
  //Clear bitmap
  with Bitmap.Canvas do begin
   Brush.Color := clBlack;
   Brush.Style := bsSolid;
   Fillrect(Rect(0, 0, Bitmap.Width, Bitmap.Height));
  end;

 ZDistance := 8; //10 is the best so far //5 is the minimum //0 is not allowed
//>>>>>>>>>>>>>>>>>>>>>>>>>> Front
 Z0 := Cube_Line_Points[14];
 Z1 := Cube_Line_Points[17];
 Z2 := Cube_Line_Points[20];
 Z3 := Cube_Line_Points[23];

 z1 := (Z0 + Z1 + Z2 + Z3) div 4;
 if (Z1 > 0) then
  Begin
   P1_X := Cube_Line_Points[12];
   P1_Y := Cube_Line_Points[13];
   P1_Z := ZDistance;

   P2_X := Cube_Line_Points[15];
   P2_Y := Cube_Line_Points[16];
   P2_Z := ZDistance;

   P3_X := Cube_Line_Points[18];
   P3_Y := Cube_Line_Points[19];
   P3_Z := ZDistance;

   P4_X := Cube_Line_Points[21];
   P4_Y := Cube_Line_Points[22];
   P4_Z := ZDistance;

   Select_Image := 1;
   DrawTexturedPolygon;
  end;
//>>>>>>>>>>>>>>>>>>>>>>>>>>>Left
 Z0 := Cube_Line_Points[17];
 Z1 := Cube_Line_Points[5];
 Z2 := Cube_Line_Points[8];
 Z3 := Cube_Line_Points[20];

 z1 := (Z0 + Z1 + Z2 + Z3) div 4;
 if (Z1 > 0) then
  Begin
   P1_X := Cube_Line_Points[15];
   P1_Y := Cube_Line_Points[16];
   P1_Z := ZDistance;

   P2_X := Cube_Line_Points[3];
   P2_Y := Cube_Line_Points[4];
   P2_Z := ZDistance;

   P3_X := Cube_Line_Points[6];
   P3_Y := Cube_Line_Points[7];
   P3_Z := ZDistance;

   P4_X := Cube_Line_Points[18];
   P4_Y := Cube_Line_Points[19];
   P4_Z := ZDistance;

   Select_Image := 2;
   DrawTexturedPolygon;
  end;
//>>>>>>>>>>>>>>>>>>>>>>>>>>>Top
 Z0 := Cube_Line_Points[23];
 Z1 := Cube_Line_Points[20];
 Z2 := Cube_Line_Points[8];
 Z3 := Cube_Line_Points[11];

 z1 := (Z0 + Z1 + Z2 + Z3) div 4;
 if (Z1 > 0) then
  Begin
   P1_X := Cube_Line_Points[21];
   P1_Y := Cube_Line_Points[22];
   P1_Z := ZDistance;

   P2_X := Cube_Line_Points[18];
   P2_Y := Cube_Line_Points[19];
   P2_Z := ZDistance;

   P3_X := Cube_Line_Points[6];
   P3_Y := Cube_Line_Points[7];
   P3_Z := ZDistance;

   P4_X := Cube_Line_Points[9];
   P4_Y := Cube_Line_Points[10];
   P4_Z := ZDistance;

   Select_Image := 3;
   DrawTexturedPolygon;
  end;
//>>>>>>>>>>>>>>>>>>>>>>>>>>>Right
 Z0 := Cube_Line_Points[14];
 Z1 := Cube_Line_Points[2];
 Z2 := Cube_Line_Points[11];
 Z3 := Cube_Line_Points[23];

 z1 := (Z0 + Z1 + Z2 + Z3) div 4;
 if (Z1 > 0) then
  Begin
   P1_X := Cube_Line_Points[12];
   P1_Y := Cube_Line_Points[13];
   P1_Z := ZDistance;

   P2_X := Cube_Line_Points[0];
   P2_Y := Cube_Line_Points[1];
   P2_Z := ZDistance;

   P3_X := Cube_Line_Points[9];
   P3_Y := Cube_Line_Points[10];
   P3_Z := ZDistance;

   P4_X := Cube_Line_Points[21];
   P4_Y := Cube_Line_Points[22];
   P4_Z := ZDistance;

   Select_Image := 4;
   DrawTexturedPolygon;
  end;
//>>>>>>>>>>>>>>>>>>>>>>>>>>>Bottom
 Z0 := Cube_Line_Points[14];
 Z1 := Cube_Line_Points[17];
 Z2 := Cube_Line_Points[5];
 Z3 := Cube_Line_Points[2];

 z1 := (Z0 + Z1 + Z2 + Z3) div 4;
 if (Z1 > 0) then
  Begin
   P1_X := Cube_Line_Points[12];
   P1_Y := Cube_Line_Points[13];
   P1_Z := ZDistance;

   P2_X := Cube_Line_Points[15];
   P2_Y := Cube_Line_Points[16];
   P2_Z := ZDistance;

   P3_X := Cube_Line_Points[3];
   P3_Y := Cube_Line_Points[4];
   P3_Z := ZDistance;

   P4_X := Cube_Line_Points[0];
   P4_Y := Cube_Line_Points[1];
   P4_Z := ZDistance;

   Select_Image := 5;
   DrawTexturedPolygon;
  end;
//>>>>>>>>>>>>>>>>>>>>>>>>>>>Back
 Z0 := Cube_Line_Points[2];
 Z1 := Cube_Line_Points[5];
 Z2 := Cube_Line_Points[8];
 Z3 := Cube_Line_Points[11];

 z1 := (Z0 + Z1 + Z2 + Z3) div 4;
 if (Z1 > 0) then
  Begin
   P1_X := Cube_Line_Points[0];
   P1_Y := Cube_Line_Points[1];
   P1_Z := ZDistance;

   P2_X := Cube_Line_Points[3];
   P2_Y := Cube_Line_Points[4];
   P2_Z := ZDistance;

   P3_X := Cube_Line_Points[6];
   P3_Y := Cube_Line_Points[7];
   P3_Z := ZDistance;

   P4_X := Cube_Line_Points[9];
   P4_Y := Cube_Line_Points[10];
   P4_Z := ZDistance;

   Select_Image := 6;
   DrawTexturedPolygon;
  end;
end;

procedure TForm1.Direction(); //This is the Artificiacal Intelegence Part of the Screen Saver //Collision Detection
Begin
 Case Direction_1 of  //Left Motion
  1: Begin
       Case Direction_2 of  //Left Motion
        1: Begin    //Up_Left
            X_Loop := X_Loop - Speed;
            Y_Loop := Y_Loop - Speed;
            Form1.Canvas.Draw(X_Loop, Y_Loop, Bitmap);
           end;
        3: Begin    //Down_Left
            X_Loop := X_Loop - Speed;
            Y_Loop := Y_Loop + Speed;
            Form1.Canvas.Draw(X_Loop, Y_Loop, Bitmap);
           end;
       end;

      if (X_Loop < 5) then
       Begin
        Direction_1 := 2;

        if (Direction_2 = 1) then
         Direction_2 := 2
        else
         Direction_2 := 4;
       end;

      if (Y_Loop < 5) then
       Begin
        Direction_2 := 3;
       end;

      if (Y_Loop > (Form1.ClientHeight - Max_Limit_Y)) then
       Begin
        Direction_2 := 1;
       end;

     end;
 end;

 Case Direction_1 of //Right Motion
  2: Begin
       Case Direction_2 of  //Left Motion
        2: Begin    //Up_Right
            X_Loop := X_Loop + Speed;
            Y_Loop := Y_Loop - Speed;
            Form1.Canvas.Draw(X_Loop, Y_Loop, Bitmap);
           end;
        4: Begin    //Down_Right
            X_Loop := X_Loop + Speed;
            Y_Loop := Y_Loop + Speed;
            Form1.Canvas.Draw(X_Loop, Y_Loop, Bitmap);
           end;
       end;

      if (X_Loop > (Form1.ClientWidth - Max_Limit_X)) then
       Begin
        Direction_1 := 1;

        if (Direction_2 = 2) then
         Direction_2 := 1
        else
         Direction_2 := 3;
       end;

      if (Y_Loop < 5) then
       Begin
        Direction_2 := 4;
       end;

      if (Y_Loop > (Form1.ClientHeight - Max_Limit_Y)) then
       Begin
        Direction_2 := 2;
       end;

     end;
 end;
end;

end.
